<?php
/*
Plugin Name: WP Group List
Plugin URI: http://wpgroup.org/wp-group-list
Description: This is a plugin for link all WordPress Blog post to here in widget.
Author: Richer Yang
Version: 1.0.4
Author URI: http://fantasyworld.idv.tw/
*/

include_once(ABSPATH . WPINC . '/class-IXR.php');
include_once(ABSPATH . WPINC . '/class-wp-http-ixr-client.php');

function wgl_install()
{
	$xmlrpc = new xmlrpc;
	$blogid = $xmlrpc->get_blogid('wpgroup', 'DApcrJqwzG5X');
	add_option('WGL_config', array('wgl_name' => 'wpgroup', 'wgl_passwd' => 'DApcrJqwzG5X', 'share_num' => 200, 'blogid' => $blogid, 'is_comment' => 1));
	add_option('WGL_widget_config', array('title' => 'WordPress Group Post', 'maxnum' => 20, 'num' => 5, 'upnum' => 1));
}
function wgl_uninstall()
{
	delete_option('WGL_config');
	delete_option('WGL_widget_config');
}
register_activation_hook( __FILE__, 'wgl_install');
register_deactivation_hook( __FILE__, 'wgl_uninstall');

$wgl_config = get_option('WGL_config');
$currentLocale = get_locale();
if( !empty($currentLocale) )
{
	$moFile = dirname(__FILE__) . '/lang/' . $currentLocale . '.mo';
	if( @file_exists($moFile) && is_readable($moFile) )
	{
		load_textdomain('wgl', $moFile);
	}
}

if( is_admin() )
{
	require_once dirname( __FILE__ ) . '/admin.php';
}

function my_substr($text, $length)
{
	if( function_exists('mb_internal_encoding') )
	{
		mb_internal_encoding(get_bloginfo('charset'));
		if( mb_strlen($text) > $length )
		{
			return mb_substr($text, 0, $length) . ' ...';
		}
		else
		{
			return $text;
		}
	}
	else
	{
		if( strlen($text) > $length )
		{
			return substr($text, 0, $length) . ' ...';
		}
		else
		{
			return $text;
		}
	}
}

function wgl_newpost($post_id, $post_data)
{
	global $wgl_config;
/*	if( $post_data->post_modified > $post_date->post_date )
	{
		return false;
	}*/
	$xmlrpc = new xmlrpc;
	$post = array();	
	$post['title'] = $post_data->post_title;
	$post['description'] = strip_tags($post_data->post_content);
	$post['description'] = str_replace("\r\n", ' ', $post['description']);
	$post['description'] = preg_replace('|\[\/?[^[\[]*]|si', '', $post['description']);
	$post['description'] = my_substr($post['description'], $wgl_config['share_num']);
	$author = get_the_author_meta('display_name', $post_data->post_author);
	$post['description'] .= "\r\n" . __('Post By: ', 'wgl') .sprintf('<a href="%3$s">%1$s</a> @ <a href="%2$s" title="%1$s">%2$s</a>', $author, get_permalink($post_data->ID), get_bloginfo('url'));
	if( !isset($wgl_config[$author . '**']) )
	{
		$new_cat = array(
			'name' => $author,
			'slug' => $author,
			'parent_id' => 0,
			'description' => get_bloginfo('name') . ' :: ' . get_bloginfo('description')
		);
		$cat = $xmlrpc->client_query('wp.newCategory', $wgl_config['blogid'], $wgl_config['wgl_name'], $wgl_config['wgl_passwd'], $new_cat);
		if( is_int($cat[0]) )
		{
			$wgl_config[$author . '**'] = true;
			update_option('WGL_config', $wgl_config);
		}
	}
	$post['categories'] = array($author);
	$post['custom_fields'] = array(array('key' => 'wgl_link', 'value' => get_permalink($post_data->ID)), array('key' => 'host_id', 'value' => md5(get_bloginfo('url'))));
	$post['mt_keywords'] = array();
	$cats = get_the_category($post_data->ID);
	if( isset($cats[0]) )
	{
		foreach( $cats AS $cat )
		{
			$post['mt_keywords'][] = $cat->cat_name;
		}
	}
	$tags = get_the_tags($post_data->ID);
	if( isset($tags[0]) )
	{
		foreach( $tags AS $tag )
		{
			$post['mt_keywords'][] = $tag->name;
		}
	}
	if( $wgl_config['is_comment'] == false )
	{
		$post['mt_allow_comments'] = 'closed';
	}
	$data = $xmlrpc->client_query('metaWeblog.newPost', $wgl_config['blogid'], $wgl_config['wgl_name'], $wgl_config['wgl_passwd'], $post, true);
	return true;
}
add_action('publish_post', 'wgl_newpost', 9999, 2);

class xmlrpc extends WP_HTTP_IXR_Client
{
	private $client;
	private $request;
	
	function xmlrpc()
	{
		$this->WP_HTTP_IXR_Client('http://wpgroup.org/xmlrpc.php');
		$this->timeout = 5;
//		$this->debug = true;
	}
	function client_query()
	{
		$args = func_get_args();
		$method = array_shift($args);
		$this->query($method, $args);
		if( $this->message->faultCode == '' )
		{
			return $this->message->params;
		}
		return false;
	}
	function get_blogid($name, $passwd)
	{
		$this->query('wp.getUsersBlogs', $name, $passwd);
		if( isset($this->message->params[0][0]['blogid']) )
		{
			return intval($this->message->params[0][0]['blogid']);
		}
		return false;
	}
}

function wgl_widget_js()
{
	wp_enqueue_script('jquery');
	wp_enqueue_style('wgl.css', plugin_dir_url( __FILE__ ) . 'wgl.css');
}

function init_wgl_widget()
{
	function wgl_widget_post($args)
	{
		extract($args);
		$option = get_option('WGL_widget_config');
		echo($before_widget . $before_title . $option['title'] . $after_title . '<div id="marquee"><dl>');
		for( $i = 1; $i <= $option['maxnum']; $i++ )
		{
			echo('<dd id="wgl_' .  $i . '"></dd>');
		}
		echo('</dl></div>' . $after_widget);
		?>
		<script type="text/javascript">
		var _ajax=true,_now=<?php echo($option['upnum']); ?>,_dff=0,_height=new Array(<?php echo(($option['maxnum']+1)); ?>);
		jQuery.ajax({type:'GET',url:'http://wpgroup.org/wgl_ajax.php?n=<?php echo($option['maxnum']); ?>&id=<?php echo(md5(get_bloginfo('url'))); ?>',cache:false,dataType:'script',beforeSend:function(xhr){xhr.setRequestHeader('Accept','text/javascript');},success:function(){_height[0]=0;for(i=1;i<=<?php echo($option['maxnum']); ?>;i++){if(_data[i]!='undefined'){jQuery('#wgl_'+i).html(_data[i]);_height[i]=_height[i-1]+jQuery('#wgl_'+i).outerHeight(true);}else{_height[i]=height[i-1]+0;}}for(i=1;i<=<?php echo($option['maxnum']); ?>;i++){_height[i+<?php echo($option['maxnum']); ?>]=_height[<?php echo($option['maxnum']); ?>]+_height[i];}jQuery('#marquee dl').append(jQuery('#marquee dl').html());jQuery('#marquee').height(_height[<?php echo($option['num']); ?>]);_ajax=false;}});
		jQuery('#marquee').hover(function(){clearInterval(MyMar);},function(){MyMar=setInterval(fMarquee,3000);});var MyMar=setInterval(fMarquee,3000);
		function fMarquee(){if(_ajax){return false;}jQuery('#marquee dl').animate({'top':-_height[_now]},800,function(){if(_now>=<?php echo($option['maxnum']); ?>){_now-=<?php echo($option['maxnum']); ?>;jQuery('#marquee dl').css({'top':-_height[_now]});}_now+=<?php echo($option['upnum']); ?>;});}
		</script>
		<?php
	}
	function wgl_widget_post_control()
	{
		$option = $newoptions = get_option('WGL_widget_config');
		if ( isset($_POST['wgl_submit']) && $_POST['wgl_submit']==1 )
		{
			$newoptions['title'] = stripslashes(strip_tags($_POST['wgl_title']));
			if( empty($newoptions['title']) )
			{
				$newoptions['title'] = 'WordPress Group Post';
			}
			$newoptions['num'] = intval($_POST['wgl_num']);
			if( $newoptions['num']<1 )
			{
				$newoptions['num'] = 1;
			}
			$newoptions['upnum'] = intval($_POST['wgl_upnum']);
			if( $newoptions['upnum']>=$newoptions['num'] )
			{
				$newoptions['upnum'] = $newoptions['num'] - 1;
			}
			if( $newoptions['upnum']<1 )
			{
				$newoptions['upnum'] = 1;
			}
			$newoptions['maxnum'] = intval($_POST['wgl_maxnum']);
			if( $newoptions['maxnum']<$newoptions['num'] )
			{
				$newoptions['maxnum'] = $newoptions['num'];
			}
			if( $newoptions['maxnum']<4 )
			{
				$newoptions['maxnum'] = 4;
			}
		}
		if ( $options != $newoptions )
		{
			update_option('WGL_widget_config', $newoptions);
		}
		?>
		<p><label for="wgl_title"><?php _e('Title:', 'wgl'); ?> <input id="wgl_title" name="wgl_title" type="text" value="<?php echo($option['title']); ?>" /></label></p>
		<p><label for="wgl_maxnum"><?php _e('Total Posts:', 'wgl'); ?> <input id="wgl_maxnum" name="wgl_maxnum" type="text" value="<?php echo($option['maxnum']); ?>" /></label></p>
		<p><label for="wgl_num"><?php _e('Show Posts:', 'wgl'); ?> <input id="wgl_num" name="wgl_num" type="text" value="<?php echo($option['num']); ?>" /></label></p>
		<p><label for="wgl_upnum"><?php _e('Winding Posts:', 'wgl'); ?> <input id="wgl_upnum" name="wgl_upnum" type="text" value="<?php echo($option['upnum']); ?>" /></label></p>
		<input type="hidden" id="wgl_submit" name="wgl_submit" value="1" />
		<?php
	}
	wp_register_sidebar_widget('wgl_post', 'WGL post', 'wgl_widget_post', null);
	wp_register_widget_control('wgl_post', 'WGL post', 'wgl_widget_post_control', null);
	if( is_active_widget(true, 'wgl_post') )
	{
		add_action('wp_head', 'wgl_widget_js', 1);
	}
}
add_action('widgets_init', 'init_wgl_widget');
?>